package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"
)

func WrapGetTaskListHandler(ctx *gin.Context) {
	handler := newGetTaskListHandler(ctx)
	baseRun(handler)
}

type GetTaskList struct {
	ctx  *gin.Context
	req  *http_model.GetTaskListRequest
	resp *http_model.CommonResponse
}

func (c GetTaskList) getContext() *gin.Context {
	return c.ctx
}

func (c GetTaskList) getResponse() interface{} {
	return c.resp
}

func (c GetTaskList) getRequest() interface{} {
	return c.req
}

func (c GetTaskList) run() {
	data := http_model.GetTaskListRequest{}
	data = *c.req
	res, err := service.Task.GetList(c.ctx, data)
	if err != nil {
		logrus.Errorf("[GetSecTaskList] call GetSecTaskList err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorParamCheck, "")
		logrus.Info("GetSecTaskList fail,req:%+v", c.req)
		return
	}
	c.resp.Message = "成功查询种草达人"
	c.resp.Data = res
	c.resp.Status = consts.ErrorSuccess
}

func (c GetTaskList) checkParam() error {
	return nil
}

func newGetTaskListHandler(ctx *gin.Context) *GetTaskList {
	return &GetTaskList{
		ctx:  ctx,
		req:  http_model.NewGetTaskListRequest(),
		resp: http_model.NewGetTaskListResponse(),
	}
}
